local Ingredient = DSTIngredient
local _Recipe2 = Recipe2
local function IsMarshLand(pt, rot)
  local ground_tile = TheWorld.Map:GetTileAtPoint(pt.x, pt.y, pt.z)
  return ground_tile and ground_tile == GROUND.MARSH
end
local mermthrone_construction = {Ingredient("pigskin", 10), Ingredient("beefalowool", 15), Ingredient("seaweed", 20)}
local function SwitchIngredient()
  local HamletDLC, ShipWreckedDLC, RoGDLC = SaveGameIndex:IsModePorkland(), SaveGameIndex:IsModeShipwrecked(),
   IsDLCEnabled(REIGN_OF_GIANTS)
  -- target DLC is RoG, vanilla is not supported because there is literally nothing to build a throne
  if HamletDLC then
    -- replace seaweed with lotus, beefalowool with beaergerfur
    mermthrone_construction[3] = Ingredient("lotus_flower", 20)
    mermthrone_construction[2] = Ingredient("beargerfur", 1)
  elseif ShipWreckedDLC then
    -- replace beefalowool with oxwool
    mermthrone_construction[2] = Ingredient("oxwool", 15)
  elseif not RoGDLC then
    -- do not add non-existent ingredients
    table.remove(mermthrone_construction, 3)
    table.remove(mermthrone_construction, 2)
  end
end
return function(builder)
  if GetConfig("switch_ingredient") then SwitchIngredient() end
  local function Recipe2(name, ingredient, tech, config)
    if config and config.builder_tag then
      if not builder or builder:HasTag(config.builder_tag) then return _Recipe2(name, ingredient, tech, config) end
    else
      return _Recipe2(name, ingredient, tech, config)
    end
  end
  -- changed recipe according to mermthrone
  -- #TODO:investigate 5 ingredient is displayed well?
  Recipe2("mermhouse_crafted", {Ingredient("boards", 4), Ingredient("cutreeds", 3), Ingredient("fish", 2)},
   TECH.SCIENCE_ONE, {
     builder_tag = "merm_builder",
     placer = "mermhouse_crafted_placer",
     testfn = IsMarshLand,
     tab = "town"
   })
  Recipe2("mermthrone", {Ingredient("boards", 5), Ingredient("rope", 5), unpack(mermthrone_construction)},
   TECH.SCIENCE_ONE, {
     builder_tag = "merm_builder",
     placer = "mermthrone_placer",
     testfn = IsMarshLand,
     tab = "town"
   })
  Recipe2("mermwatchtower", {Ingredient("boards", 5), Ingredient("tentaclespots", 1), Ingredient("spear", 2)},
   TECH.SCIENCE_ONE, {
     builder_tag = "merm_builder",
     placer = "mermwatchtower_placer",
     testfn = IsMarshLand,
     tab = "town"
   })
  -- not ported
  --[[
    Recipe2("wurt_turf_marsh", {Ingredient("cutreeds", 1), Ingredient("spoiled_food", 2)}, TECH.NONE, {
        builder_tag = "merm_builder",
        product = "turf_marsh",
        numtogive = 4,
        tab = "town"
    })
    ]]
  -- not ported
  --[[
    Recipe2("mermhat", {Ingredient("fish", 1), Ingredient("cutreeds", 1), Ingredient("twigs", 2)}, TECH.NONE, {
        builder_tag = "merm_builder",
        tab = "dress"
    })]]

end
