-- DST is the same
-- local DSTActionHandler=ActionHandler
-- local ActionHandler=DSTActionHandler
local function EquipPaddle(inst)
    if not inst:HasTag("mime") then inst.AnimState:OverrideSymbol("paddle", "swap_paddle", "paddle") end
    -- IA: TODO allow custom paddles?
    inst.AnimState:OverrideSymbol("wake_paddle", "swap_paddle", "wake_paddle")
end
local PatchPaddle = function(sg)
    -- from Island Adventures
    local old = sg.onenter
    sg.onenter = function(inst)
        EquipPaddle(inst)
        old(inst)
    end
end
local PatchPaddleEvent = function(self)
    -- from Island Adventures
    local old = self.fn
    self.fn = function(inst, ...)
        EquipPaddle(inst)
        return old(inst, ...)
    end
end
return {
    PATCHEDSTATES = {
        row_start = PatchPaddle,
        funnyidle = function(state)
            local old = state.onenter
            local function outof(val, min, max)
                return val < min or val > max
            end
            local function CheckNotHealthy(inst)
                return (inst.components.poisonable and inst.components.poisonable:IsPoisoned())
                           or (inst.components.temperature and outof(inst.components.temperature:GetCurrent(), 5, 60))
                           or (inst.components.hunger and inst.components.hunger:GetPercent() < TUNING.HUNGRY_THRESH)
                           or (inst.components.sanity and inst.components.sanity:IsCrazy()) or inst:HasTag("groggy")
            end
            local new = function(inst)
                if not CheckNotHealthy(inst) then
                    if inst.customidleanim and math.random()<0.5 then
                        inst.AnimState:PlayAnimation(FunctionOrValue(inst.customidleanim, inst))
                        return true
                    end
                end
                return false
            end
            state.onenter = function(inst)
                if new(inst) then return end
                return old(inst)
            end
        end
    },
    PATCHEDEVENTS = {sailunequipped = PatchPaddleEvent}
}
