local function drequire(filename) return utils.onemod("dst_wurt_" .. filename) end

local function prequire(filename) return utils.onemod("postinit/" .. filename) end
local print = print
if not GetConfig("debug") and GetIsWorkshop() then print = function() end end
print("DST Wurt Mod init")
-- register
table.insert(CHARACTER_GENDERS.FEMALE, "wurt")
AddModCharacter("wurt")
table.shallowmergeinto(Assets, {
  Asset("IMAGE", "images/saveslot_portraits/wurt.tex"),
  Asset("ATLAS", "images/saveslot_portraits/wurt.xml"),
  Asset("IMAGE", "images/selectscreen_portraits/wurt.tex"),
  Asset("ATLAS", "images/selectscreen_portraits/wurt.xml"),
  Asset("IMAGE", "images/selectscreen_portraits/wurt_silho.tex"),
  Asset("ATLAS", "images/selectscreen_portraits/wurt_silho.xml"),
  Asset("IMAGE", "bigportraits/wurt.tex"),
  Asset("ATLAS", "bigportraits/wurt.xml")
})

-- import inventory images as a table
-- replace with DST variables
print("DST Wurt mod import invimages")
local Asset = DSTAsset
local xml = "images/inventoryimages_dst_wurt"
RegisterInventoryItemAtlasFromXML(xml .. ".xml")
table.insert(Assets, Asset("IMAGE", xml .. ".tex"))
table.insert(Assets, Asset("ATLAS", xml .. ".xml"))
-- import languages
print("DST Wurt Mod import language")
utils.mod("scripts/TranslateLanguage")
-- import libs
print("DST Wurt Mod import libs")
utils.mod("scripts/", {"ActionUtils", "SGUtils"})
-- import tunings
print("DST Wurt Mod import tunings")
local DSTTuning = drequire("tuning")
table.mergeinto(TUNING, DSTTuning())
DSTTunings = nil
-- expose my API
expose("UPVALUE", UPVALUE)
print("DST Wurt Mod import postinits")
-- import postinit as a table
local AllPostinit = drequire("postinits")
for i, v in ipairs(AllPostinit.component) do utils.com(v, prequire("components/" .. v)) end
for i, v in ipairs(AllPostinit.prefab) do utils.prefab(v, prequire("prefabs/" .. v)) end
for i, v in ipairs(AllPostinit.widget) do utils.class("widgets/" .. v, prequire("widgets/" .. v)) end
for i, v in ipairs(AllPostinit.screens) do utils.class("screens/" .. v, prequire("screens/" .. v)) end
for i, v in ipairs(AllPostinit.brain) do utils.brain(v .. "brain", prequire("brain/" .. v)) end
for i, v in ipairs(AllPostinit.root) do utils.class(v, prequire(v)) end
local preinit = {components = {"locomotor", 'sanity'}}
for k, v in pairs(preinit) do
  for i, v2 in ipairs(v) do utils.require(k .. "/" .. v2, utils.onemod("scripts/preinit/" .. k .. "/" .. v2 .. ".lua")) end
end
-- import shaders
-- nothing
-- import prefabs as a table
PrefabFiles = drequire("prefabs")
-- add minimap atlas
utils.minimap("minimap/minimap_dst_wurt.xml")
table.insert(Assets, Asset("IMAGE", "minimap/minimap_dst_wurt.tex"))
table.insert(Assets, Asset("ATLAS", "minimap/minimap_dst_wurt.xml"))
-- import non prefab assets
-- local extaassets = drequire("extraassets")
-- for k, v in ipairs(extaassets) do
-- table.insert(Assets, MakeAsset(unpack(v)))
-- end
-- extaassets = nil
-- import actions as a table
print("DST Wurt Mod import actions")
local AllActions = drequire("actions")
AddDSTActions(AllActions)
AllActions = nil
local AllComponentActions = drequire("componentactions")
for k, v in pairs(AllComponentActions) do for comp, fn in pairs(v) do DSTAddComponentAction(k, comp, fn) end end
AllComponentActions = nil
-- import stategraph
print("DST Wurt Mod import sg")
local AllSG = drequire("sg")
AddDSTSG(AllSG)
AllSG = nil
-- import recipes as a function
print("DST Wurt Mod import recipes")
utils.player_raw(drequire("recipes"))
utils.prefab("world", function(inst) inst:AddComponent("mermkingmanager") end)
-- import brain
-- nothing to do
