return function(LocoMotor)
  function LocoMotor:SetFasterOnGroundTile(ground_tile, is_faster)
    if not ground_tile then return end
    --	if self.ismastersim then
    self.faster_on_tiles[ground_tile] = is_faster
    if is_faster then
      self.inst:AddTag("turfrunner_" .. tostring(ground_tile))
    else
      self.inst:RemoveTag("turfrunner_" .. tostring(ground_tile))
    end
    --	end
  end
  function LocoMotor:DSTUpdateGroundSpeedMultiplier()
    local x, y, z = self.inst.Transform:GetWorldPosition()
    local tile = TheWorld.Map:GetTileAtPoint(x, 0, z)
    if self:IsFasterOnGroundTile(tile) then self.groundspeedmultiplier = self.fastmultiplier end
  end
  function LocoMotor:IsFasterOnGroundTile(ground_tile)
    if not ground_tile then return false end
    local rider = self.inst.components.rider
    local mount = rider ~= nil and rider:IsRiding() and rider:GetMount() or nil
    if mount ~= nil then
      return mount.components.locomotor ~= nil and mount.components.locomotor.faster_on_tiles[ground_tile]
    end
    return self.faster_on_tiles[ground_tile] == true
  end
  local UpdateGroundSpeedMultiplier = LocoMotor.UpdateGroundSpeedMultiplier
  function LocoMotor:UpdateGroundSpeedMultiplier(...)
    UpdateGroundSpeedMultiplier(self, ...)
    if self.groundspeedmultiplier == 1 then self:DSTUpdateGroundSpeedMultiplier(...) end
  end
end
